#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_RedPackagelotteryCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_RedPackagelotteryCFG> Fish_RedPackagelotteryCFG::msSingleton(nullptr);

int Fish_RedPackagelotteryCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_RedPackagelotteryCFGData* Fish_RedPackagelotteryCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_RedPackagelotteryCFGData>& Fish_RedPackagelotteryCFG::GetMapData()
{
	return mMapData;
}

void Fish_RedPackagelotteryCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_RedPackagelotteryCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_RedPackagelotteryCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mRedPageItem = element->IntAttribute("RedPageItem");
		data.mRedPageQuantity = element->IntAttribute("RedPageQuantity");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void Fish_RedPackagelotteryCFG::Load()
{
	Load("../Config/Fish_RedPackagelotteryCFG.xml");
}

Fish_RedPackagelotteryCFG* Fish_RedPackagelotteryCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_RedPackagelotteryCFG());
	}
	return msSingleton.get();
}
